/*
 * Copyright 2026 Oleg Borodin <onborodin@gmail.com>
 */
package imageoper

import (
	"context"
	"fmt"
	"io"
	"net/http"
	"strconv"
)

type PutUploadParams struct {
	ContentType   string
	ContentLength string
	ContentRange  string
	Name          string
	Reference     string
	Digest        string
	Reader        io.Reader
}
type PutUploadResult struct {
	Location string
}

func (oper *Operator) PutUpload(ctx context.Context, operatorID string, params *PutUploadParams) (*PutUploadResult, int, error) {
	var err error
	res := &PutUploadResult{}

	if params.Reference == "" {
		err = fmt.Errorf("Empty reference")
		return res, http.StatusBadRequest, err
	}
	if params.Name == "" {
		err = fmt.Errorf("Empty name")
		return res, http.StatusBadRequest, err
	}
	if params.Digest == "" {
		err = fmt.Errorf("Empty digest")
		return res, http.StatusBadRequest, err
	}
	if params.ContentType != "application/octet-stream" {
		err = fmt.Errorf("Wrong conten type: %s", params.ContentType)
		return res, http.StatusBadRequest, err
	}

	resName := params.Name
	oper.iLock.WaitAndLock(resName)
	defer oper.iLock.Done(resName)

	var contentLength int64
	if params.ContentLength != "" {
		contentLength, err = strconv.ParseInt(params.ContentLength, 10, 64)
		if err != nil {
			err = fmt.Errorf("Cannot convert Content-Length=%s to integer: %v", params.ContentLength, err)
			return res, http.StatusBadRequest, err
		}

	}
	if contentLength != 0 {
		recsize, err := oper.store.WriteUpload(params.Reference, params.Reader)
		if err != nil {
			return res, http.StatusInternalServerError, err
		}
		if contentLength != 0 && recsize != contentLength {
			oper.store.RemoveUpload(params.Reference)
			err = fmt.Errorf("Mismatch upload recorded size and content length")
			return res, http.StatusInternalServerError, err
		}
		if err != nil {
			return res, http.StatusInternalServerError, err
		}
		res.Location = fmt.Sprintf("/v2/%s/blobs/%s", params.Name, params.Digest)
	}

	err = oper.store.LinkUpload(params.Reference, params.Name, params.Digest)
	if err != nil {
		err = fmt.Errorf("Failed to link upload %s, err: %v", params.Reference, err)
		return res, http.StatusInternalServerError, err
	}

	res.Location = fmt.Sprintf("/v2/%s/blobs/%s", params.Name, params.Digest)
	return res, http.StatusCreated, err
}
